SYSTEM sieve;
(* X window visualization of prime sieve | Braunl 1992 *)
CONST n=1000;
CONFIGURATION list [2..n];
CONNECTION  (* none *);

SCALAR  prime, step, win: INTEGER;
        ch              : CHAR;
VECTOR  removed         : BOOLEAN;

BEGIN
  win  := OpenAbswindow(n, n DIV 3); 
  SetColor(COLOR(0,0,0)); (* black *)
  step := 0;

  PARALLEL
    REPEAT
      prime:= REDUCE.FIRST(DIM1);
      removed := DIM1 MOD prime = 0; (* remove multiples *)
      inc(step);
      SetPixel(DIM1, step);
    UNTIL removed
  ENDPARALLEL;

  WriteString("Press RETURN for termination"); WriteLn;
  Read(ch);
  CloseWindow(win);
END sieve.

